<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2004 Olivier Meunier and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#eze
# ***** END LICENSE BLOCK *****
#
# Contributor : Christophe OPOIX
#


global $blog;

function importposts($url)
{
	global $blog;

	$str = file_get_contents($url);
	//on vire le caca du debut
	$str = preg_replace("#.*(\\<blog\\>.*\\</blog\\>)#ms", "\\1", $str);

	// on separe les posts parce que c'est plus simple...
	$arr = preg_split("#\\<post\\>#ms", $str);

	// et maintenant les posts avec la date et tout et tout
	$done = true;
	$len = sizeof($arr);
	for ($i = 1; $i < $len; $i++){
		preg_match("#.*\\<time\\>(.*)\\</time\\>.*\\<title\\>(.*)\\</title\\>.*\\<content\\>(.*)\\</content\\>.*#ms", $arr[$i], $matches);
		$time = $matches[1];
		$title = $matches[2];
		$content = $matches[3];
		//print_r($matches);
		if ($title == "")
			$title = "Untitled";
		$time =  strtotime($time);
		$id = $blog->addPost($_SESSION['sess_user_id'], $title, "", "", $content, "ouais", 1);
		if ($id == NULL) {
			$done = FALSE;
			break ;
		}
		$blog->updPost($id, $title, "", "", $content, "", 1, "html", true, true, true, $time);
	}
	return ($done);
}

function importarchives($str)
{
	$done = true;
	$arr = preg_split("#\\<archiveurl\\>#ms", $str);
	$len = sizeof($arr);
	for ($i = 1; $i < $len; $i++) {
		preg_match("#(.*)\\</archiveurl\\>#ms", $arr[$i], $matches);
		if (!importposts($matches[1])) {
			$done = false;
		}
	}
	return ($done);
}

function bloggerimport($url)
{
	$str = file_get_contents($url);

	//on vire le caca du debut
	$str = preg_replace("#.*(\\<blog\\>.*\\</blog\\>)#ms", "\\1", $str);

	// on choppe le nom du blog
	preg_match("#\\<blogtitle\\>(.*)\\</blogtitle\\>#", $str, $matches);
	$name = $matches[1];
	$done = importarchives($str);
	return ($done);
}


$blogger_ini_file = dirname(__FILE__).'/bloggerimport.ini';
$blogger_ini_content = parse_ini_file($blogger_ini_file);


$err = '';
$url = 'tools.php?p=bloggerimport';

$is_writable = false;


if (!is_writable($blogger_ini_file)) {
	$err = '<p>'.sprintf(__('Config file %s, is not writable.'),"<strong>$blogger_ini_file</strong>").'</p>';
} else {
	$is_writable = true;


	# Modification du fichier
	if (!empty($_POST))
	{
		$importurl = trim($_POST['importurl']);
		$objIni = new iniFile($blogger_ini_file);
		$objIni->editVar('importurl', $importurl);
		$objIni->saveFile();
		$blogger_ini_content['importurl'] = $importurl;

		$arry_err = array();

		if (!preg_match('#^http://([a-z0-9A-Z]*\\.)*.*\\.[a-zA-Z]{3}/*$#',$importurl)) {
			$arry_err[] = __('You must enter a valid url.');
		}

		if (count($arry_err) > 0)
		{
			$err .= '<ul>';
			foreach ($arry_err as $v) { $err .= '<li>'.$v.'</li>'; }
			$err .= '</ul>';
		}
		else
		{
			$error = false;
			$done = bloggerimport($importurl);

			if ($done) {
				header('Location: '.$url.'&done=1');
				exit;
			} else {
				$err = __('An error occured while importing.');
			}
		}
	}
}


/* Affichage
-------------------------------------------------------- */


$mySubMenu->addItem(__('Configuration'), $url.'&config', 'images/ico_edit.png', FALSE);
$mySubMenu->addItem(__('Usage'), $url.'&usage', 'images/ico_goto.png', FALSE);


buffer::str('<h2>'.__('BloggerImport').'</h2>');

if($err != '')
{
	buffer::str('<div class="erreur"><p><strong>'.__('Error(s)').' :</strong></p>'.$err.'</div>');
}

if ($is_writable)
{
	if (!empty($_GET['done'])) {
		buffer::str(
		'<p class="message">'.__('Posts sucessfully imported.').'</p>'
		);
	}


	if (isset($_GET['usage'])){
		buffer::str(


		'<h3>'.__('Setup').'</h3>'.
		'<p>' .__('Use the following template in Blogger').'</p>'.
		'<blockquote><pre>'.htmlentities(file_get_contents(dirname(__FILE__)."/template.xml")).'</pre></blockquote>'.
		'<p>'.__('Now, in the settings...').'</p>'.
		'<ul><li>'.__('Choose "Timestamp Format" that looks like "5/1/2005 01:50:59 AM".').'</li>'.
		'<li>'.__('Choose the same encoding as your dotclear installation').'</li>'.
		'<li>'.__('Respublish').'</li></ul>'.
		'<h3>'.__('Usage').'</h3>'.
		'<p>'.__('Simply choose the adress of your Blogger blog and everything should go fine').'</p>'.
		'<h3>'.__('Notes').'</h3>'.
		'<p>'.__('The category chosen is the first one, and the author is the current one, this might be options in a future version, for now... well, it isn\'t.').'</p>'


		);
	}
	else{
		buffer::str(

		'<form action="'.$url.'" method="post">'.

		'<fieldset class="clear">'.

		'<legend>'.__('Configuration').'</legend>'.
		'<p class="field"><label for="importurl"><strong>'.__('Blog url').'&nbsp;:</strong> '.
		'</label>'.
		form::field('importurl',40,'',htmlspecialchars($blogger_ini_content['importurl'])).'</p>'.

		'</fieldset>'.

		'<p class="field"><input class="submit" type="submit" value="'.__('Launch import').'" /></p>'.
		'</form>'
		);
	}

}
?>
